package il.ac.tau.cs.sw1.io;

import java.io.Closeable;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;

public class Copy {

	public static void copy() throws IOException {
		Reader in = new InputStreamReader(System.in);
		Writer out = new OutputStreamWriter(System.out);

		copy(in, out);
	}

	public static void copy(String src, String dst) throws IOException {
		Reader in = new FileReader(src);
		Writer out = new FileWriter(dst);

		copy(in, out);
	}

	private static void copy(Reader in, Writer out) throws IOException {
		int c;
		try {
			while ((c = in.read()) != -1) {
				out.write(c);
				out.flush();
			}
		} finally {
			closeIgnoringException(in);
			closeIgnoringException(out);
		}
	}

	private static void closeIgnoringException(Closeable c) {
		if (c != null) {
			try {
				c.close();
			} catch (IOException e) {
				// Deliberately left empty; There is nothing we can do if
				// close fails
			}
		}
	}

	public static void main(String[] args) {
		try {
			if (args.length == 0) {
				copy();
			} else if (args.length == 2) {
				copy(args[0], args[1]);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
